/* par_cnf.c */ 
/* This file is Dante output,
   which you may modify and use
   in your application without restriction.
*/
#include <stdio.h> 
#include <string.h> 
#include "par.h" 
#include "par_cnf_types.h" 

/* -------------PROTOTYPES ------------ */
static int par_cmp (PAR *par, int type, char *name);
       int par_cnf(PAR *par); 
static int par_task(PAR *par); 
static int par_tstates(PAR *par); 
static int par_queue(PAR *par); 
static int par_include_file(PAR *par); 
 #define SYM (par -> symbol)
  #define IVALUE (par -> i_value) 
  #define INT atoi(par->symbol)
  #define DBL atof(par->symbol)
 
/* ------------------------------------------- */
int
par_cnf(PAR *par)
{


L1:	if(par_task(par)){goto L1;}
	if(par_queue(par)){goto L1;}
	if(par_include_file(par)){goto L1;}
		else return 1;
}
/* ------------------------------------------- */
static int
par_task(PAR *par)
{
 #include "task.h"
         TASK  task;      
        
	if(par_cmp(par, 316, "task")){}
		else return 0;
	if(par_cmp(par, 311, "name")){}
		else par_cnf_error(par, 1, "task", "name");
	if(par_cmp(par, 319, "qstring")){ strcpy (task.name, SYM);  }
		else par_cnf_error(par, 2, "task", "qstring");
	if(par_cmp(par, 307, "id")){}
		else par_cnf_error(par, 3, "task", "id");
	if(par_cmp(par, 318, "integer")){ task.id = INT; }
		else par_cnf_error(par, 4, "task", "integer");
	if(par_cmp(par, 313, "priority")){}
		else par_cnf_error(par, 5, "task", "priority");
	if(par_cmp(par, 318, "integer")){ task.priority = INT;   }
		else par_cnf_error(par, 6, "task", "integer");
	if(par_cmp(par, 315, "state")){}
		else par_cnf_error(par, 7, "task", "state");
	if(par_tstates(par)){ task.state = IVALUE;      }
		else par_cnf_error(par, 8, "task", "tstates");
	if(par_cmp(par, 312, "path")){}
		else par_cnf_error(par, 9, "task", "path");
	if(par_cmp(par, 319, "qstring")){ strcpy (task.path, SYM);  }
		else par_cnf_error(par, 10, "task", "qstring");
	if(par_cmp(par, 305, "d")){}
		else par_cnf_error(par, 11, "task", "d");
	if(par_cmp(par, 317, "double")){ task.d = DBL;  }
		else par_cnf_error(par, 12, "task", "double");
	if(par_cmp(par, 306, "end")){ pr_task (&task);  return 1;}
		else par_cnf_error(par, 13, "task", "end");
}
/* ------------------------------------------- */
static int
par_tstates(PAR *par)
{

	if(par_cmp(par, 301, "TASK_NOT_READY")){ IVALUE = 1;  return 1;}
	if(par_cmp(par, 302, "TASK_READY")){ IVALUE = 2;  return 1;}
	if(par_cmp(par, 303, "TASK_RUNNING")){ IVALUE = 3;  return 1;}
	if(par_cmp(par, 304, "TASK_WAITING")){ IVALUE = 4;  return 1;}
	if(par_cmp(par, 300, "TASK_DONE")){ IVALUE = 5;  return 1;}
		else return 0;
}
/* ------------------------------------------- */
static int
par_queue(PAR *par)
{
 #include "queue.h"
         QUEUE queue;
        
	if(par_cmp(par, 314, "queue")){}
		else return 0;
	if(par_cmp(par, 311, "name")){}
		else par_cnf_error(par, 14, "queue", "name");
	if(par_cmp(par, 319, "qstring")){ strcpy (queue.name, SYM); }
		else par_cnf_error(par, 15, "queue", "qstring");
	if(par_cmp(par, 307, "id")){}
		else par_cnf_error(par, 16, "queue", "id");
	if(par_cmp(par, 318, "integer")){ queue.id = INT; }
		else par_cnf_error(par, 17, "queue", "integer");
	if(par_cmp(par, 310, "max_msgs")){}
		else par_cnf_error(par, 18, "queue", "max_msgs");
	if(par_cmp(par, 318, "integer")){ queue.max_msgs = INT; }
		else par_cnf_error(par, 19, "queue", "integer");
	if(par_cmp(par, 309, "max_len")){}
		else par_cnf_error(par, 20, "queue", "max_len");
	if(par_cmp(par, 318, "integer")){ queue.max_len = INT; }
		else par_cnf_error(par, 21, "queue", "integer");
	if(par_cmp(par, 306, "end")){ pr_queue (&queue);  return 1;}
		else par_cnf_error(par, 22, "queue", "end");
}
/* ------------------------------------------- */
static int
par_include_file(PAR *par)
{

	if(par_cmp(par, 308, "include_file")){}
		else return 0;
	if(par_cmp(par, 319, "qstring")){ par_cnf_file (par, par->symbol); return 1;}
		else par_cnf_error(par, 23, "include_file", "qstring");
}
/* ------------------------------------ */
extern FILE *yyin;
extern char *yytext;
static int par_cmp (PAR *par, int type, char *name)
{
  yyin = par->fd;
  par->req_type = type;
  if (par->match)
   {
      par->type = yylex();
     strcpy (par->symbol, yytext);
  }
  if (type == (par->type))
  {
       par->match = 1;
       return 1;
  }
  else
  {
       par->match = 0;
       return 0;
  }
}
