/* par_cnf_rwtbl.c */
/* This file is Dante output,
   which you may modify and use
   in your application without restriction.
*/
#include <string.h> 
#include "par.h" 
#include "par_cnf_types.h" 

typedef struct 
{ 
    char   *name;
    int    type;
}RWTBL; 

#define RWTBL_SIZE 17
static const RWTBL rwtbl[RWTBL_SIZE] = 
{
   {"TASK_DONE",	300 },
   {"TASK_NOT_READY",	301 },
   {"TASK_READY",	302 },
   {"TASK_RUNNING",	303 },
   {"TASK_WAITING",	304 },
   {"d",	305 },
   {"end",	306 },
   {"id",	307 },
   {"include_file",	308 },
   {"max_len",	309 },
   {"max_msgs",	310 },
   {"name",	311 },
   {"path",	312 },
   {"priority",	313 },
   {"queue",	314 },
   {"state",	315 },
   {"task",	316 },
};
int par_cnf_rwtbl (PAR *par, int default_type)
{
  int i = 0;
  int j = RWTBL_SIZE - 1;
  int k;

  /* Binary search. */
  while (i <= j)
    {
      k = (i + j) >> 1;
      switch (cmpstr (par->symbol, rwtbl[k].name))
      {
      case -1: j = k - 1; break;
      case  0: par->type = rwtbl[k].type; return rwtbl[k].type; break;
      case  1: i = k + 1; break;
      }
    }
  if (default_type == 0)
  {
	fprintf (stderr,
	"ERROR: Search of reserved word table failed.\n");      
	fprintf (stderr,
	"ERROR: Could not find [%s].\n", par->symbol);      
  }
  return default_type;
} 

