/* par_tst.c */ 
/* This file is Dante output,
   which you may modify and use
   in your application without restriction.
*/
#include <stdio.h> 
#include <string.h> 
#include "par.h" 
#include "par_tst_types.h" 

/* -------------PROTOTYPES ------------ */
static int par_cmp (PAR *par, int type, char *name);
       int par_tst(PAR *par); 
static int par_types(PAR *par); 
static int par_oper(PAR *par); 
static int par_tst_lex(PAR *par); 
static int par_tokens(PAR *par); 

/* ------------------------------------------- */
int
par_tst(PAR *par)
{


L1:	if(par_types(par)){goto L1;}
		else return 1;
}
/* ------------------------------------------- */
static int
par_types(PAR *par)
{

	if(par_cmp(par, 305, "identifier")){ printf ("IDEN: [ %d %s]\n", par->type, par->symbol);  return 1;}
	if(par_cmp(par, 307, "literal")){ printf ("LITERAL: [ %d %s]\n", par->type, par->symbol);  return 1;}
	if(par_cmp(par, 308, "qstring")){ printf ("QSTR: [ %d %s]\n", par->type, par->symbol);  return 1;}
	if(par_cmp(par, 303, "bstring")){ printf ("BSTR: [ %d %s]\n", par->type, par->symbol);  return 1;}
	if(par_cmp(par, 306, "integer")){ 
           printf ("INTEGER: ");
           printf ("[ %d %s]\n", par->type, par->symbol); 
        return 1;}
	if(par_cmp(par, 304, "double")){          
         printf ("DECIMAL: ");      
         printf ("[ %d %s]\n", par->type, par->symbol); 
        return 1;}
	if(par_cmp(par, 300, "resword1")){ printf ("RES:  [ %d %s]\n", par->type, par->symbol);  return 1;}
	if(par_cmp(par, 301, "resword2")){ printf ("RES:  [ %d %s]\n", par->type, par->symbol);  return 1;}
	if(par_oper(par)){ printf ("OPR:  [ %d %s]\n", par->type, par->symbol);  return 1;}
		else return 0;
}
/* ------------------------------------------- */
static int
par_oper(PAR *par)
{

	if(par_cmp(par, 60, "<")){return 1;}
	if(par_cmp(par, 302, "==")){return 1;}
	if(par_cmp(par, 62, ">")){return 1;}
		else return 0;
}
/* ------------------------------------------- */
static int
par_tst_lex(PAR *par)
{
par_lex_space (par);
	if(par_tokens(par)){
          if(par->print_lexout)
            printf("LEX: [%d %s]\n", par->type, par->symbol);
         return 1;}
		else return 0;
}
/* ------------------------------------------- */
static int
par_tokens(PAR *par)
{

	if(par_lex_alnum(par)){ par->type = par_tst_rwtbl (par, TYPE_identifier);  return 1;}
	if(par_lex_bstring(par)){ par->type = TYPE_bstring;  return 1;}
	if(par_lex_number(par)){if ( par->type == 'I')
                         par->type = TYPE_integer;
                        else par->type = TYPE_double;  return 1;}
	if(par_lex_literal(par)){ par->type = TYPE_literal;  return 1;}
	if(par_lex_qstring(par)){ par->type = TYPE_qstring;  return 1;}
	if(par_lex_muloper(par)){ par->type = par_tst_optbl (par);  return 1;}
		else return 0;
}
/* ------------------------------------ */
static int
par_cmp (PAR *par, int req_type, char *name)
{
  par->req_type = req_type;
  if (par->match)
      par_tst_lex (par);
  par->match = (req_type == (par->type))?1:0;
  return par->match;
}
