/* par_sym.h */
/*
   Copyright (C) 2006 John W. Jordan
   All Rights Reserved
*/
/*
  This file is part of Dante.
  Dante is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the license, or
  ( at your option ) any later version.
  Dante is distributed in the hope that it will be usefull,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A OARTICULAR PURPOSE. See the
  GNU General Public License for more detaile.
  You should have received a copy of the GNU General Public License
  along with Dante; if not write to the Free Software
  Foundation. Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */

#ifndef SYM_H
#define SYM_H

#include "par_stack.h"

typedef struct sym_t
{
  char *name;			/* Token name. */
  int type;			/* Type code. */
  char *flex_def;		/* Flex def for mvt's. */
  int reserved;			/* Reserved word indicator. */
} SYM;


SYM *sym_add_symbol_sorted (STACK * stack, char *name);
SYM *sym_find_symbol (STACK * stack, char *name);
SYM *sym_set_type_by_name (STACK * stack, char *name, int type);

void sym_set_type (SYM * sym, int type);
int  sym_isres (STACK * stack, char *name);
void sym_rwtbl (STACK * stack, FILE * fd);
void sym_pr_symtbl (STACK * stack);
void sym_add_flexdef (STACK * stack, char *name, char *flex_def);
void sym_pr_rwtbl_def_to_file (STACK * stack, FILE * fd);
void sym_pr_rwtbl_to_file (STACK * stack, FILE * fd);
int sym_set_table_codes (STACK * stack, int code);

#endif
