/* par_lex_input.c */
/*
   Copyright (C) 2006 John W. Jordan
   All Rights Reserved

  This file is part of Dante.
  Dante is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the license, or
  ( at your option ) any later version.
  Dante is distributed in the hope that it will be usefull,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A OARTICULAR PURPOSE. See the
  GNU General Public License for more detaile.
  You should have received a copy of the GNU General Public License
  along with Dante; if not write to the Free Software
  Foundation. Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
USA
*/

#include <stdio.h>
#include <string.h>
#include "par.h"
/* ------------------------------------------- */
static const int debug = 0;
/* --------------------------------------------- */
int
par_lex_input (PAR * par)
{
   if (par->buffer_input)
    {
      if (par->buffer)
        {
          if (par->buf_pos == par->buf_len)
            par->lex_c = -1;
          else
            par->lex_c = par->buffer[(par->buf_pos)++];
        }
      else
        {
          fprintf (stderr, 
            "PAR_LEX_INPUT: Input buffer ptr. is null\n");
          exit (1);
        }
    }  
    else
    par->lex_c = fgetc (par->fd);

  /* End of file - use 0 */
  if (par->lex_c == (-1))
      par->lex_c = 0;
   
  par->lex_t = par->lex_c;

  /* Newline */

  if (par->lex_c == '\n')
    par->lineno++; 
  
if (par->print_input)
    {
      if (par->lex_c == '\n')
	printf ("\n%4d ", par->lineno);
      else
	printf ("%c", par->lex_c);
    }

     if(debug) printf ("INPUT: lex_c [%c %d] lex_t [%c %d] \n", 
               par->lex_c,  par->lex_c, par->lex_t, par->lex_t);
     
  return 1;
}
