/* par_lex_input.c */
/*
   Copyright (C) 2006 John W. Jordan
   All Rights Reserved

  This file is part of Dante.
  Dante is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the license, or
  ( at your option ) any later version.
  Dante is distributed in the hope that it will be usefull,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A OARTICULAR PURPOSE. See the
  GNU General Public License for more detaile.
  You should have received a copy of the GNU General Public License
  along with Dante; if not write to the Free Software
  Foundation. Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
USA
*/
#include <stdio.h>
#include <string.h>
#include "par.h"

/* ------------------------------------ */
int
par_lex_input (PAR * par)
{
  if (par->buffer_input = 0)
    {
      if (par->buffer)
	{
	  if (par->buf_pos == par->buf_len)
	    par->lex_c = 0;
	  else
	    par->lex_c = par->buffer[(par->buf_pos)++];
	}
      else
	{
	  fprintf (stderr, "PAR_LEX_INPUT: Input buffer ptr. is null\n");
	  exit (1);
	}
    }
  else
    par->lex_c = fgetc (par->fd);

  if (par->lex_c == (-1))
    {
      par->lex_c = 0;
      par->lex_t = 0;
    }

  /* 
     Assign type to character. 
     Same as these std. functions: 
     isalpha lex_t = 'L'
     isdigit lex_t = 'D'
     isspace lex_t = 'S'
     Except newline is not considered space.
     Punctuation characters type is equal to char. value.
     i.e. ispunct  lex_t = lex_c 
     !isprint lex_t = 'E' - this is an error condition as
     non printable char. should never appear int test input.
     This could occur if a non text file was input.
   */
   
  else if (isspace (par->lex_c))
    {
      par->lex_t = 'S';
      /* Newline - not considered as a space char. */
      if (par->lex_c == '\n')
	{
	  par->lineno++;
	  par->lex_t = par->lex_c;
	}
    }

  else if (isalpha (par->lex_c))
      par->lex_t = 'L';
   

  else if (isdigit (par->lex_c))
      par->lex_t = 'D';
    

  else if (ispunct (par->lex_c))
      par->lex_t = 'P';
   
  else if (!isprint (par->lex_c))
    {
      fprintf (stderr,
	       "LEX INPUT: non printable character [dec. %d hex. %x]\n",
	       par->lex_c, par->lex_c);
      exit (1);
    }

  if (par->print_input)
    {
      if (par->lex_c == '\n')
	printf ("\n%4d ", par->lineno);
      else
	printf ("%c", par->lex_c);
    }
  return 1;
}
