/* par_dan_rwtbl.c */
/* This file is Dante output,
   which you may modify and use
   in your application without restriction.
*/
#include <string.h> 
#include "par.h" 
#include "par_dan_types.h" 

typedef struct 
{ 
    char   *name;
    int    type;
}RWTBL; 

#define RWTBL_SIZE 8
static const RWTBL rwtbl[RWTBL_SIZE] = 
{
   {"dan_buffer_input",	300 },
   {"dan_flex_def",	301 },
   {"dan_lex_fun",	302 },
   {"dan_no_support",	303 },
   {"dan_set_res",	304 },
   {"dan_sub_of",	305 },
   {"dan_type_code",	306 },
   {"dan_use_flex",	307 },
};
int par_dan_rwtbl (PAR *par, int default_type)
{
  int i = 0;
  int j = RWTBL_SIZE - 1;
  int k;

  /* Binary search. */
  while (i <= j)
    {
      k = (i + j) >> 1;
      switch (cmpstr (par->symbol, rwtbl[k].name))
      {
      case -1: j = k - 1; break;
      case  0: par->type = rwtbl[k].type; return rwtbl[k].type; break;
      case  1: i = k + 1; break;
      }
    }
  if (default_type == 0)
  {
	fprintf (stderr,
	"ERROR: Search of reserved word table failed.\n");      
	fprintf (stderr,
	"ERROR: Could not find [%s].\n", par->symbol);      
  }
  return default_type;
} 

