/* par_gen_act.c */
/*
   Copyright (C) 2006 John W. Jordan
   All Rights Reserved
*/
/* 
  This file is part of Dante.
  Dante is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the license, or
  ( at your option ) any later version.
  Dante is distributed in the hope that it will be usefull,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A OARTICULAR PURPOSE. See the
  GNU General Public License for more detaile.
  You should have received a copy of the GNU General Public License
  along with Dante; if not write to the Free Software
  Foundation. Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
USA
*/
#include <unistd.h>
#include "par.h"
#include "dan_act.h"

/* --------------------------------------------------------- */
void gen_actions (PAR * par, FILE * fd);
/* --------------------------------------------------------- */
void
par_gen_act (PAR * par)
{
  FILE *fd;
  NODE *net;
  NODE *rule;
  NODE *node;

  char *pname;
  char NAME[64];
  char filename[64];

  pname = par->pname;
  strcpy (filename, "par_");
  strcat (filename, pname);
  strcat (filename, "_act.c");

  /* If the file exists don`t replace it. */
  if (access (filename, F_OK) == 0)
    {
      if (par->opt_verbose)
	{
	  printf ("%s already exists.\n", filename);
	  printf ("A new %s will not be generated.\n", filename);
	}
      return;
    }

  net = (NODE *) par->top_rule;

  fd = fopen (filename, "w");
  if (!fd)
    {
      printf ("Could not open %s\n", filename);
      exit (1);
    }

  
  fprintf (fd, "/* par_act.c */ \n");
  par_gen_notice (fd);
  fprintf (fd, "#include \"par.h\" \n");


  fprintf (fd, "/* ------------------------------------ */\n");
  fprintf (fd, "void\npar_%s_act (PAR *par)\n", pname);
  fprintf (fd, "{ \n");
  fprintf (fd, "/* ACTION ROUTINE INITIALIZATION */ \n");
  fprintf (fd, "} \n\n");
  
  fclose (fd);
}


