/* par_gen_file.c */
/*
   Copyright (C) 2006 John W. Jordan
   All Rights Reserved
*/
/* 
  This file is part of Dante.
  Dante is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the license, or
  ( at your option ) any later version.
  Dante is distributed in the hope that it will be usefull,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A OARTICULAR PURPOSE. See the
  GNU General Public License for more detaile.
  You should have received a copy of the GNU General Public License
  along with Dante; if not write to the Free Software
  Foundation. Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
USA
*/
#include "par.h"
/* --------------------------------------- */
void
par_gen_file (PAR * par)
{
  FILE *fd;
  char filename[32];
  char procname[32];
  char *pname;

  pname = (char *) par->pname;

  strcpy (filename, "par_");
  strcat (filename, pname);
  strcat (filename, "_file.c");
  strcpy (procname, pname);

  fd = fopen (filename, "w");
  fprintf (fd, "/* %s */ \n", filename);
   par_gen_notice (fd);
  
  fprintf (fd, "#include \"par.h\"\n");
  fprintf (fd, "void par_%s_file (PAR *par, char *fname)\n", pname);
  fprintf (fd, "{\n");
  fprintf (fd, "\tFILE     *new_fd;\n");
  fprintf (fd, "\tFILE     *old_fd = 0;\n");
  fprintf (fd, "\tint      buffer_input;\n\n");

  fprintf (fd, "\t/* Open input file. */\n\n");

  fprintf (fd, "\tif ((new_fd = fopen (fname, \"r\")) == (FILE *)0)\n");
  fprintf (fd, "\t{\n");
  fprintf (fd,
	   "\t\tfprintf(stderr, \"PAR_FILE:Could not open input file.\");");
  fprintf (fd, "\t\tperror(\"ERROR: OPEN\");\n");
  fprintf (fd, "\texit (-1);\n");
  fprintf (fd, "\t}\n");

  fprintf (fd, "\told_fd = par->fd;\n");
  fprintf (fd, "\tpar -> fd = new_fd;\n\n");

  fprintf (fd, "\tbuffer_input = par->buffer_input;\n");
  fprintf (fd, "\tpar->buffer_input = 0;\n");

  fprintf (fd, "\tpar_%s (par);\n", procname);
  fprintf (fd, "\tpar->fd = old_fd;\n");
  fprintf (fd, "\tfclose (new_fd);\n");
  fprintf (fd, "\tpar->buffer_input = buffer_input;\n");
  fprintf (fd, "\tif (par->fd)par->match = 1;\n");
  fprintf (fd, "\t else par->match = 0;\n");
  fprintf (fd, "}\n");
  fclose (fd);
}
