/* par_gen_init.c */
/*
   Copyright (C) 2006 John W. Jordan
   All Rights Reserved
*/
/* 
  This file is part of Dante.
  Dante is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the license, or
  ( at your option ) any later version.
  Dante is distributed in the hope that it will be usefull,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A OARTICULAR PURPOSE. See the
  GNU General Public License for more detaile.
  You should have received a copy of the GNU General Public License
  along with Dante; if not write to the Free Software
  Foundation. Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
USA
*/
/* Generates a procedure to init par.h. */
#include <unistd.h>
#include "par.h"
/* ---------------------------------------------- */
void
par_gen_init (PAR * par)
{
  FILE *fd;
  char filename[32];
  char *pname;
  
  pname = (char *)par->pname;
  strcpy (filename, "par_");
  strcat (filename, pname);
  strcat (filename, "_init.c");

  /* If the file exists dont replace it. */
  if (access (filename, F_OK) == 0)
    {
      if (par->opt_verbose)
	{
	  printf ("An init procedure already exists.\n");
	  printf ("A init procedure will not be generated.\n");
	}
      return;
    }

  fd = fopen (filename, "w");
  fprintf (fd, "/* par_%s_init.c */\n", pname);
  par_gen_notice (fd);
  fprintf (fd, "#include \"par.h\"\n");
  fprintf (fd, "void par_%s_init (PAR *par, int symbol_limit)\n", pname);
  fprintf (fd, "{\n");
  fprintf (fd, "   par->fd = 0;\n");
  fprintf (fd, "   par->lineno = 1;\n");
  fprintf (fd, "   par->symbol = (char *)xmalloc(symbol_limit + 2);\n");
  fprintf (fd, "   par->symbol[0] = 0;\n");
  fprintf (fd, "   par->match = 1;\n");
  fprintf (fd, "   par->act = 0;\n");
  fprintf (fd, "   par ->sindex = 0;\n");
  fprintf (fd, "   par ->slimit = symbol_limit;\n");
  fprintf (fd, "   par->lex_m = 1;\n");
  fprintf (fd, "   par->buffer = 0;\n");
  fprintf (fd, "   par->buf_pos = 0;\n");
  fprintf (fd, "   par->buffer_input = 0;\n");
  fprintf (fd, "   par->print_input = 0;\n");
  fprintf (fd, "   par->print_lexout = 0;\n");
  fprintf (fd, "} \n");
  fclose (fd);
}
