/* par_gen_types_h.c */
/*
   Copyright (C) 2006 John W. Jordan
   All Rights Reserved
*/
/* 
  This file is part of Dante.
  Dante is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the license, or
  ( at your option ) any later version.
  Dante is distributed in the hope that it will be usefull,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A OARTICULAR PURPOSE. See the
  GNU General Public License for more detaile.
  You should have received a copy of the GNU General Public License
  along with Dante; if not write to the Free Software
  Foundation. Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
USA
*/
#include <stdio.h>
#include <string.h>
#include "par.h"
#include "dan_act.h"
#include "par_sym.h"
/* -------------- PROTOTYPES OF LOCAL PROCEDURES --------------------- */
/* ------------------------------------------------------------------- */
 void
par_gen_types_h (PAR * par)
{
  FILE *fd;
  void *rwtbl;
  void *typetbl;
  SYM *sym;
  int k;
  int rwtbl_size = 0;
  int n = 300;
  char *pname;
  char filename[64];

  pname = par->pname;
  rwtbl = par->rwtbl;
  typetbl = par->typetbl;
   
  strcpy (filename, "par_");
  strcat (filename, pname);
  strcat (filename, "_types.h");
 
  fd = fopen (filename, "w");
  fprintf (fd, "/* par_%s_types.h */\n\n", pname);
  
  par_gen_notice (fd);
  
  k = 0;
  while (sym = (SYM *) Item (par->typetbl, k++))
      if  ((par->gen_lexer) &&
           (sym->type == -1))
	{	
	      fprintf (stderr,
		       "ERROR: Lexer type for [%s] is not defined.\n",
		       sym->name);
	      fprintf (stderr, "Look for a missing dan_type_code directive.\n");
	}
    
  /* Reserved Words. */
  k = 0;
  while (sym = (SYM *) Item (par->rwtbl, k++))
    {
	fprintf (fd, "#define RESWD_%s %d\n", sym->name, sym->type);
    }
    
    /* Types. */
    k = 0;
  while (sym = (SYM *) Item (par->typetbl, k++))
    {
	fprintf (fd, "#define TYPE_%s %d\n", sym->name, sym->type);
    }  
    
  fprintf (fd, "\n");
  fclose (fd);
}

