/* par_set_codes.c */
/*
   Copyright (C) 2006 John W. Jordan
   All Rights Reserved
*/
/* 
  This file is part of Dante.
  Dante is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the license, or
  ( at your option ) any later version.
  Dante is distributed in the hope that it will be usefull,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A OARTICULAR PURPOSE. See the
  GNU General Public License for more detaile.
  You should have received a copy of the GNU General Public License
  along with Dante; if not write to the Free Software
  Foundation. Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
USA
*/
#include "par.h"
#include "dan_act.h"
#include "par_sym.h"
/* ------------------------------------------------------------ */
static int set_rwtbl (PAR * par, int code);
static int set_typetbl (PAR * par, int code);
static int set_optbl (PAR * par, int code);
static int set_typetbl_lf (PAR * par);
/* ------------------------------------------------------------ */
void
par_set_codes (PAR * par)
{
 int code = 300;
 
  code = set_rwtbl (par, code);
  code = set_optbl (par, code);

  if (par->gen_lexer)
    set_typetbl_lf (par);
  else
    code = set_typetbl (par, code);
}

/* --------------------------------------------------------- */
int
set_rwtbl (PAR * par, int code)
{
  SYM *sym;
  int k;

  k = 0;
  while (sym = (SYM *) sym_item (par->rwtbl, k++))
    {
      if (sym->type == (-1))
	sym->type = code++;
    }
  return code;
}

/* --------------------------------------------------------- */
static int
set_typetbl (PAR * par, int code)
{
  SYM *sym;
  int k;

  k = 0;
  while (sym = (SYM *) sym_item (par->typetbl, k++))
    {
      if (sym->type == (-1))
	{
	  sym->type = code++;
	}
    }
  return code;
}

/* --------------------------------------------------------- */
/* If a literal is a single character, then the characters
   value is assigned as its code. For multiple character
   literals a sequential code is assigned. 
*/
static int set_optbl (PAR * par, int code)
{
  SYM *sym;
  int k;

  k = 0;
  while (sym = (SYM *) sym_item (par->littbl, k++))
    {
      if (sym->type == (-1))
	{
	  if (strlen (sym->name) == 1)
	    sym->type = sym->name[0];
	  else
	    sym->type = code++;
	}
    }
  return code;
}

/* --------------------------------------------------------- */
/* Type table is set differently for lexer functions. */
static int
set_typetbl_lf (PAR * par)
{
  SYM *sym;
  int k;

  k = 0;
  while (sym = (SYM *) sym_item (par->typetbl, k++))
    {
      if (sym->type == (-1))
	{
	  fprintf (stderr, "PAR_SET_CODES: ERROR\n");
	  fprintf (stderr, "Lexer Function\n");
	  fprintf (stderr, "Lexer type for [%s] is not defined.\n",
		   sym->name);
	  exit (1);
	}
    }
}
